package com.example.spiritlevel;

import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;


public class SpiritLevelActivity extends Activity implements SensorEventListener {
  private SpiritLevelDrawableView spiritlevelView;
  private SensorManager manager;
  private Sensor gravity;

  private static final String TAG = "Spiritlevel";

  /** Called when the activity is first created. */
  @Override
  public void onCreate(Bundle savedInstanceState)
  {
    super.onCreate(savedInstanceState);
    spiritlevelView = new SpiritLevelDrawableView(this);
    setContentView(spiritlevelView);

    manager = (SensorManager)getSystemService(SENSOR_SERVICE);
    gravity = manager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
  }


  protected void onResume() {
    super.onResume();
    manager.registerListener(this, gravity, 
        SensorManager.SENSOR_DELAY_GAME);
  }

  protected void onPause() {
    super.onPause();
    manager.unregisterListener(this);
  }

  public void onAccuracyChanged(Sensor sensor, int accuracy) {
    spiritlevelView.invalidate();
  }

  public void onSensorChanged(SensorEvent event) {
    /*Log.i(TAG, "onSensorChanged() " + event.values[0] + " " +
        event.values[1] + " " + event.values[2]);*/
    spiritlevelView.moveBubble(event.values[0], event.values[1]);
    spiritlevelView.invalidate();
  }
}
